<?php

class formWidgetContentRandomOptions extends cmsForm {

    public function init($options=false) {

                $cats_list     = array();
		$datasets_list = array('0'=>'');
		$fields_list   = array(''=>'');

                if (!empty($options['ctype_id'])){

                    $content_model = cmsCore::getModel('content');
                    $ctype = $content_model->getContentType($options['ctype_id']);
                    $cats  = $content_model->getCategoriesTree($ctype['name']);

                    if ($cats){
                        foreach($cats as $cat){
                            if ($cat['ns_level'] > 1){
                                $cat['title'] = str_repeat('-', $cat['ns_level']) . ' ' . $cat['title'];
                            }
                            $cats_list[$cat['id']] = $cat['title'];
                        }
                    }

                    $datasets = $content_model->getContentDatasets($options['ctype_id']);
                    if ($datasets){ $datasets_list = array('0'=>'') + array_collection_to_list($datasets, 'id', 'title'); }

                    $fields = $content_model->getContentFields($ctype['name']);
                    if ($fields){ $fields_list = array(''=>'') + array_collection_to_list($fields, 'name', 'title'); }

		}

        return array(

            array(
                'type'   => 'fieldset',
                'title'  => LANG_OPTIONS,
                'childs' => array(

                    new fieldList('options:ctype_id', array(
                        'title'     => LANG_CONTENT_TYPE,
						'disable_array_key_rules' => true,
                        'generator' => function($item) {

                            $model = cmsCore::getModel('content');
                            $tree = $model->getContentTypes();

                            return array_collection_to_list($tree, 'id', 'title');

                        }
                    )),

                    new fieldList('options:category_id', array(
                        'title'  => LANG_CATEGORY,
						'disable_array_key_rules' => true,
                        'items'  => $cats_list,
                        'parent' => array(
                                'list' => 'options:ctype_id',
                                'url'  => href_to('content', 'widget_cats_ajax')
                        )
                    )),

                    new fieldList('options:dataset', array(
                        'title'  => LANG_WD_CONTENT_RANDOM_DATASET,
						'disable_array_key_rules' => true,
                        'items'  => $datasets_list,
                        'parent' => array(
                                'list' => 'options:ctype_id',
                                'url'  => href_to('content', 'widget_datasets_ajax')
                        )
                    )),

                    new fieldList('options:image_field', array(
                        'title'  => LANG_WD_CONTENT_RANDOM_IMAGE,
						'disable_array_key_rules' => true,
                        'items'  => $fields_list,
                        'parent' => array(
                                'list' => 'options:ctype_id',
                                'url'  => href_to('content', 'widget_fields_ajax')
                        ),

                    )),

                    new fieldList('options:teaser_field', array(
                        'title'  => LANG_WD_CONTENT_RANDOM_TEASER,
						'disable_array_key_rules' => true,
                        'items'  => $fields_list,
                        'parent' => array(
                                'list' => 'options:ctype_id',
                                'url'  => href_to('content', 'widget_fields_ajax')
                        )
                    )),

                    new fieldNumber('options:teaser_max_length', array(
                        'title'   => LANG_WD_CONTENT_RANDOM_TEASER_MAX_LENGTH,
                        'hint'    => LANG_WD_CONTENT_RANDOM_TEASER_MAX_LENGTH_HINT,
                        'units'   => LANG_WD_CONTENT_RANDOM_TEASER_MAX_LENGTH_UNITS,
                        'default' => 0
                    )),

                    new fieldNumber('options:amount_items', array(
                        'title'   => LANG_WD_CONTENT_RANDOM_AMOUNT_ITEMS,
                        'default' => 1,
                        'rules'   => array(
                            array('required')
                        )
                    )),

                    new fieldCheckbox('options:show_details', array(
                       'title' => LANG_WD_CONTENT_RANDOM_DETAILS,
                    )),

                    new fieldNumber('options:auto_reload', array(
                        'title'   => LANG_WD_CONTENT_RANDOM_AUTO_RELOAD,
                        'hint'    => LANG_WD_CONTENT_RANDOM_AUTO_RELOAD_HINT,
                        'units'   => LANG_WD_CONTENT_RANDOM_AUTO_RELOAD_UNITS,
                        'default' => 0
                    )),

                )
            ),

        );

    }

}